import java.io.*;
import java.util.StringTokenizer;

/**
 * Konvertiert Labyrinthe von 1999 ins Format von 2001.
 * @author Johannes Zander (?, decompiliert), Christian Semrau
 */
public class MazMaze{

    private static void convertMaze(String s) throws Exception {
        try {
            String s1;
            String s2;
            if(s.toUpperCase().endsWith(".MAZ")) {
                s1 = s;
                s2 = s.substring(0, s.length() - 4) + ".maze";
            } else {
                s1 = s + ".MAZ";
                s2 = s + ".maze";
            }
            BufferedReader bufferedreader = new BufferedReader(new FileReader(s1));
            BufferedWriter bufferedwriter = new BufferedWriter(new FileWriter(s2));
            StringTokenizer stringtokenizer = new StringTokenizer(bufferedreader.readLine(), " ");
            int i = Integer.parseInt(stringtokenizer.nextToken());
            int j = Integer.parseInt(stringtokenizer.nextToken());
            int homex = Integer.parseInt(stringtokenizer.nextToken());
            int homey = Integer.parseInt(stringtokenizer.nextToken());

            bufferedwriter.write("[maze2001]");
            bufferedwriter.newLine();
            bufferedwriter.write("[mazeLevels:1]");
            bufferedwriter.newLine();
            bufferedwriter.write("[width:" + i + "]");
            bufferedwriter.newLine();
            bufferedwriter.write("[height:" + j + "]");
            bufferedwriter.newLine();
            bufferedwriter.write("[constants]");
            bufferedwriter.newLine();
            bufferedwriter.write("7,");
            bufferedwriter.newLine();

            bufferedwriter.write("[level:0]");
            bufferedwriter.newLine();

            int l = 0;
            int i1 = 1;
            for(int j1 = 1; j1 <= j; j1++) {
                StringTokenizer stringtokenizer1 = new StringTokenizer(bufferedreader.readLine(), " ");
                for(int k1 = 0; k1 < i; k1++) {
                    int l1 = Integer.parseInt(stringtokenizer1.nextToken(), 16);
                    int i2 = borderTrans[l1 >> 12];
                    int j2 = l1 & 0xff;
                    if((l1 & 0xf00) != 0) {
                        l = k1;
                        i1 = j1;
                    }
                    bufferedwriter.write(i2 + "," + j2 + ",0,0,0,0,0,0,");
                }

                bufferedwriter.newLine();
            }

            bufferedwriter.write("[beamers:0]");
            bufferedwriter.newLine();
            bufferedwriter.write("[halfbeamers:0]");
            bufferedwriter.newLine();
            bufferedwriter.write("[home]");
            bufferedwriter.newLine();
            bufferedwriter.write(homex+","+homey+",0,");
            bufferedwriter.newLine();
            bufferedwriter.write("[centers]");
            bufferedwriter.newLine();
            bufferedwriter.write(homex+","+homey+",");
            bufferedwriter.newLine();

            bufferedwriter.close();
            bufferedreader.close();
        } catch(Exception exception) {
            throw exception;
        }
    }

    public static void main(String args[]) throws Exception {
        if(args.length != 1) {
            System.out.println("usage: java MazMaze <file>");
            System.out.println("Converts maze format <=1999 (.maz) to 2001 (.maze)");
            System.out.println("Christian Semrau, 2001");
            System.exit(1);
        }
        try {
            convertMaze(args[0]);
        } catch(Exception exception) {
            System.out.println("Cannot convert maze: " + exception.toString());
            throw exception;
        }
    }

    static final int borderTrans[] = {
        0, 4, 2, 6, 1, 5, 3, 7, 8, 12, 
        10, 14, 9, 13, 11, 15
    };

}
